//
// AecPci ISR example.c
//--------------------------------------------------------
//	 AecPci ISR example
//	Uses the Win32 API calls to create a simple example of
//	how to use the interrupt service routine in connection
//	with the AEC PCI?-TC devices (PCI & PCIe).
//
//   Displays " hh:mm:ss:ff" in client area and interrupt count
//		for reader (and generator and video field) interrupts
//
//	REVISION: 
//		Dec 2008	NEW - B1
//
//
//	NOTE: This is NOT an MFC based program.
//			In order to modify for MFC, you will need to ...????? (TBD)
//--------------------------------------------------------
//#include "stdafx.h"
#include <windows.h>
#include <winioctl.h>		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>

#include <winioctl.h>
#include "AECioctl.h"        // This defines the IOCTL constants.
#include "Time.h"

//#include "AECiNTTC.h"		//PROTOTYPES OF THE AEC_NTTC.DLL FUNCTIONS
//This example (new for PCI devices) makes the calls directly to the DRIVER
//The DLL will be modified to include the calls to this driver TOO.

#define		true	1
#define		false	0

#define     PCI_DEVICE_NAME     "AecPci"	//BASE device Name - Hard coded in the DRIVER

HANDLE	hDevice = INVALID_HANDLE_VALUE;

char *sLinkName = "\\\\.\\AecPci0";
char *sLinkNameE = "\\\\.\\AecPCIe0";	//'AEC' device zero

//VARIABLE DEFINITIONS
// -- These are used in ISR too!
volatile int	iOtherCnt, iVidCnt, iGenCnt, iReadCnt, iGpiCnt;
int	i1_4A, i5_8A, i9_12A, i13pA, i0A;
int	i1_4B, i5_8B, i9_12B, i13pB, i0B;
int	i1_4C, i5_8C, i9_12C, i13pC, i0C;
int	i1g,i2g,i3g, i4g, i5g, i6g, i7g;
int a,b,c,d,e,f;

WCHAR str_DeviceInfo[60];
int iLwchar;
DWORD	Cnt1, Cnt2, Cnt3, DelFq, DelCnt, CntDif, toc;

volatile BOOL	bRnew, bGnew, bVnew, bGPInew;
ULONG	lRTdat, lRUdat;
ULONG	lGTdat, lGUdat;
ULONG	lGPIdat;
HANDLE	hAecPci; //, hAecPciX;

HWND	hwnd;			//GLOBAL access
int		iMB;
BOOL	ReaderAvailable, GeneratorAvailable, VideoAvailable;
BOOL	returnval1;
volatile BOOL exiting = false;
volatile BOOL DONEexitingIsrThread = false;

DWORD	RetDw;
int		aecint;
BOOL    IoctlResult;

UCHAR	iCode;
UCHAR	BrdCapCode;					//byte read from offset 08h
char	buffer[30];
char	hhmmssff[50];		//data string to hold formated unpacked dataC
char	charStr[20], rev[4];//character string to hold data sent to screen

ULONG data4, len, portaddress;

//FUNCTION PROTOTYPES
DWORD	TcISR1(HANDLE);	//my 1 isr (EVENT processing)
BOOL	DoReadWriteAction(HANDLE, enum AECPCI_ACTION, ULONG, PULONG, PULONG); //was (in error) enum AECPCI_ACTION_ITEM act
BOOL	DoReadWriteActionISR(HANDLE, enum AECPCI_ACTION, ULONG, PULONG, PULONG); //was (in error) enum AECPCI_ACTION_ITEM act
BOOL	DoReadWriteActionEventSetup(HANDLE, enum AECPCI_ACTION, HANDLE, PULONG, PULONG); //was (in error) enum AECPCI_ACTION_ITEM act
int		LtoStrTm(ULONG, char*);
int		LtoStr12B(ULONG, char*);	//FOR GPI display
UCHAR	deviceName[MAX_PATH];

//use this next line for win32 build
long WINAPI WndProc (HWND, UINT, WPARAM, LPARAM) ; //window proceedure (WndProc) PROTOTYPE
//Use Next line if x64 build
//LRESULT WndProc (HWND, UINT, WPARAM, LPARAM) ; //window proceedure (WndProc) PROTOTYPE

HDC			hdc;				
PAINTSTRUCT	ps;					
RECT		rect;				
MSG			msg;	//Global message structure that several
				    // functions use as a parameter

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{


	BOOL	device_opened = FALSE;		//if successful in opening PCI device-->true
	HANDLE	hThreadTcISR1;               // Thread TcISR handle
	LONG	threadIdTcISR1;              // ID of thread TcISR
	BOOL    IoctlResult;
	int		iMB;
	//int i;

    static char szAppName[] = "AEC PCI?-TC INTERRUPT-EVENT TEST" ;
    //HWND	 hwnd ;		/changed to global
    WNDCLASS	 wndclass ;
	bRnew = FALSE;
	bGnew = FALSE;
	bVnew = FALSE;

	//i = clock();	//??

    if (!hPrevInstance) // used to allow the creation of only one wndclass
          {
		  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		
		  wndclass.lpfnWndProc	 = WndProc ;				
		  wndclass.cbClsExtra	 = 0 ;					
		  wndclass.cbWndExtra	 = 0 ;					
		  wndclass.hInstance	 = hInstance ;				
		  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	
		  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	
		  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	
		  wndclass.lpszMenuName  = NULL ;				
		  wndclass.lpszClassName = szAppName ;				

		  RegisterClass (&wndclass) ;				
		  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "AecPCI?-TC ISR-Event EXAMPLE",		     // window text/header
		    //WS_THICKFRAME | WS_SYSMENU,	     // window style
			WS_BORDER | WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX,
		    150,				     // initial x position
		    150,				     // initial y position
		    0x250,			     // window width
		    0x80,			     // window height
            NULL,                // parent window handle
            NULL,                // window menu handle
            hInstance,           // program instance handle
		    NULL) ;				// creation parameters

    // Copy the device name into the name buffer.
	//The driver will be consistent in the device number it assigns to each
	//of the AEC PCI-TC boards in the machine. The device number depends upon
	//the PCI slot the board is installed in and its position relative to any
	//others in the machine. In any case, the first board that is found in the
	//scan (enumeration) will be labled "0", either a PCIe-TC or PCI-TC, in
	//that order.

		//Try to open PCIe-TC first
	hAecPci = CreateFile(
                sLinkNameE,	//  "\\\\.\\AecPCIe0",       // Open the Device "file"
                GENERIC_READ | GENERIC_WRITE,
                FILE_SHARE_READ | FILE_SHARE_WRITE,	//NULL (do not share if COM device)
                NULL,
                OPEN_EXISTING,
                0,		//FILE_FLAG_OVERLAPPED, ????????
                NULL
                );
               
    if (hAecPci == INVALID_HANDLE_VALUE)        // Was the device opened?
    {			//if NOT PCIe-TC, then try PCI-TC...
		hAecPci = CreateFile(
                sLinkName,	//  "\\\\.\\AecPci0",       // Open the Device "file"
                GENERIC_READ | GENERIC_WRITE,
                FILE_SHARE_READ | FILE_SHARE_WRITE,	//NULL (do not share if COM device)
                NULL,
                OPEN_EXISTING,
                0,		//FILE_FLAG_OVERLAPPED, ????????
                NULL
                );
               
		if (hAecPci == INVALID_HANDLE_VALUE)        // Was the device opened?
		{
			//If get here, there is NO AEC PCI?-TC device found (or available) on the machine
			//printf("Unable to open the device.\n");
			//int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType); 
			iMB = MessageBox(hwnd, "Unable to open the Aec PCI?-TC device.",
				NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
				MB_ICONSTOP | MB_OK); 
			exit(1);
		}
		else	returnval1 = TRUE;	//Have a PCI-TC
    }
	else	returnval1 = TRUE;	//Have a PCIe-TC

//--------------------------------
		// Note that this is important!! Make this program have highest Priority
		// if you feel that the program does NOT respond to the interrupt
		// events are processed quickly enough. It is done here for this purpose.
	SetPriorityClass ( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );

//--------------------------------
	//---------- Device setup note:
	//Do NOT Set the hardware 'INTA' interrupt enable bit within the
	// PCI/PCIe device (at offset FE.4) for POLLED operations
	// OR until you have set up things to be ready for IRQs.
	// This call makes sure that the INTA enable  is NOT set
	// writing 0x00000000 to Offset FC (Write4 must be used per 
	// documentation (refman.pdf)!) It is NOT enabled at powerup (default)

//*++
	// Determine what this device can do!
	// The device 'capabilities' is bit encoded at offset 08h.
	// This program reads this (Read1) byte and then sets program
	// flow flags to steer what is done as the example program 
	// operates.
	portaddress = 0x00000008;		//Read1 from 0x08	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hAecPci, Read1, portaddress, &data4, &len);
	//All of the 'DoReadWriteAction... calls could have a return check like
	// the following, but most are omitted for ease in translation and understanding
	// of the program order of operations.
    if (!IoctlResult)    //error  // Did the IOCTL fail?
    {
        //printf("Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "R1 08",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK); 
		goto exit_routine;				//Do NOT go on, bad problem!	
    }
	//Set capabilities flags
	BrdCapCode = (UCHAR)data4;	//the 'low byte' is what we want
		//If bit is set... (Register mapping)
		//bit 7=Vitc	Generator	installed
		//bit 6=Vitc	Reader		installed
		//bit 5=LTC		Generator	installed
		//bit 4=LTC		Reader		installed
		//bit 3=OSD		(OnScreenDisplay, PCI-TC only) installed
		//bit 1=Serial(PCI)/GPI(PCIe ?) installed
		ReaderAvailable = FALSE;
		GeneratorAvailable = FALSE;
		VideoAvailable = FALSE;

	if ((BrdCapCode & BIT7) != 0)	//VGen
	{
		GeneratorAvailable = TRUE;
		VideoAvailable = TRUE;
	}
	if ((BrdCapCode & BIT6) != 0)	//VRdr
	{
		ReaderAvailable = TRUE;
		VideoAvailable = TRUE;	//if OSD?
	}
	if ((BrdCapCode & BIT5) != 0)	//LGen
	{
		GeneratorAvailable = TRUE;
		VideoAvailable = TRUE;
	}
	if ((BrdCapCode & BIT4) != 0)	//LRdr
	{
		ReaderAvailable = TRUE;
		//VideoAvailable = TRUE;
	}

	
	//----------
	//In this sample application, I have chosen to use a board register that
	// is otherwise not used much as a pass through register to get a message
	// back and forth between the ISR worker thread and the main thread.
	// The PCI?-TC register 33h is used to set up the HH (hours) info related
	// to setting up the time code comparator. This example does NOT use the
	// comparator functionality and so this byte address is used for this alternate
	// purpose. Other methods could be used to accomplish the same "messageing"
	// Clear the register to indicate 'run', Set MSB (bit7) to indicate 'exit'.
	portaddress = 0x00000033;	//Write1 to 0x33	
	data4 = 0x00;				//
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
		iMB = MessageBox(hwnd, "W1 00h@33h",
			NULL, MB_ICONSTOP | MB_OK); 
	}


//-------------- 
// Now create the thread to handle the Interrupts/Events (and initialization & cleanup).
// SINCE THE BOARD has ALREADY been put into a "paused" mode, (see all of 
// the above) the thread may be started once the PRIORITY has been set.
//--------------
	
	if (returnval1)	// if a 'device' has been opened...
	{
		hThreadTcISR1  = CreateThread(
			NULL, 
			0,
			(LPTHREAD_START_ROUTINE)TcISR1, 
			hAecPci,			//Pass the device handle to the worker thread
			CREATE_SUSPENDED, 
			&threadIdTcISR1);

		//Did the thread get created... (this code assumes YES, doesn't verfy)...
		// This is important(especially on slower machines)!! 
		// Make this Thread have highest Priority
		//		or interrupts/events will not be processed quickly enough
		SetThreadPriority(hThreadTcISR1, THREAD_PRIORITY_TIME_CRITICAL);

        // Start up the isr threads
		RetDw = ResumeThread(hThreadTcISR1); // start this thread now
	}

	//Now show the application window and keep it updated based on what changes.
	//This part of the code is quite crude, but is easy to follow.
    ShowWindow (hwnd, nCmdShow) ;	
    UpdateWindow (hwnd) ;			
	
	InvalidateRect ( hwnd, NULL, 0 );
	GetMessage (&msg, NULL, 0, 0);
    do					//LOOP TILL THE PROGRAM IS EXITED
	{
		TranslateMessage (&msg) ;				
		DispatchMessage (&msg) ;				
		//InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
		do
		{
			Sleep(50);	//don't be a processor hog!	//check for changes often, periodic timer
			if (bRnew || bGnew  || bVnew || bGPInew)	//These values are SET in ISR thread
			{
				InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
			}			
		}
		while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))); //while no msg
		//Nonzero -> success, Zero -> failure
	    // look for any messages (allows Windows access to Main loop)

		TranslateMessage (&msg) ;				
		DispatchMessage (&msg) ;				
		InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
	}
    while (GetMessage (&msg, NULL, 0, 0));	//keep looping while NOT exiting (Alt+F4)
 
	TranslateMessage (&msg) ;		//We are going to exit now...				
    DispatchMessage (&msg) ;					

	//======================================================================
exit_routine:
	//Pass the message to the worker thread to stop looping, clean up and exit
	portaddress = 0x00000033;	//Write1 to 0x33	//This is a device register
								//that is otherwise used in the comparator ops.
	data4 = 0x80;				//Normal "not allowed/not used" value
								//This program uses this register to handshake threads
								//This is a hard way to pass info to the ISR thread
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
		iMB = MessageBox(hwnd, "W1 FFh@33h",
			NULL, MB_ICONSTOP | MB_OK); 
	}
	//----------

	exiting = true;
		//	THE NEXT ITEMS ARE IMPORTANT WHEN EXITING THE PROGRAM
		//  THAT HAS BEEN USING INTERRUPTS/EVENTS.
		//
		//1)Force an interrupt,  by sending a dummy command
		//	( or have the event wait time out as is done in this example)
		//  Purpose: This will allow the ISR thread to exit cleanly
		//	if it has not already done so. 
		// Repeat... for queued IRPs? (until isr thread has exited...)
		//2)
		//  Do this AFTER confirmation that the ISR thread has
		//  exited!
		//  Clear the IntA enable bit at offset FE.4 by
		//  writing 0x00000000 to Offset FC (Write4 must be used!)
		//
		//These are done in the following segements!
		//Sleep(1000);
		
//----------
	portaddress = 0x0000002E;	//Write1 to 0x2E	
	data4 = 0x00;			//DISABLE automatic INTTERPT (READ/GEN/GPI/Video)ENABLES on exit
							//This DOES NOT disable command response interrupts, which can
							//be controlled carefully by 'writing a command to offset 2Fh'.
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
	    //printf("\nW1 0@2E Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "W1 00@2E",
			NULL, MB_ICONSTOP | MB_OK); 
		goto final_exit;	
	}
	//veryfiy that the register does indeed have '00h' value.
	IoctlResult = DoReadWriteAction(hAecPci, Read1, portaddress, &data4, &len);
	if ((data4 & 0x000000FF) != 0x00)
		iMB = MessageBox(hwnd, "R1 @2E !=0", NULL, MB_ICONSTOP | MB_OK); 

//----------
	//do .... 
	//{
	// w1(2f) ffh	//dummy command
	//check to see if there is a pending 'int'
	// r1(fe.0)	//note value
	// r1(0f)
	// w1(2f) 00h	//enable next
	// w1(2f) ffh	//dummy command
	//check to see if there is a pending 'int'
	// r1(fe.0) //see if different than prior (should have bit set here, even if not before)
	//if '1'
	//		r1(0f)	
	//		w1(2f) 00
	//if '0'
	//		w1(2f) 00	}
	//		while (!DONEexitingIsrThread);

	//cause a command response - IRQ looping has been turned off (ie: exiting = TRUE)
	//This will force a "command response" interrupt operation to occur, but will 
	//NOT re-enable the board to generate any more driver calls (or Event waits) 
	//to handle interupts.  The ISR will clear 
	//this interrupt and if there is an ISR thread running, it will end 
	//because the EXITING flag is now TRUE (and the 'handshaking at 33.7h !=0)! 
	// See the "while (!exiting)" code in the ISR for the details.
	if (!DONEexitingIsrThread)	//if the ISR worker thread has NOT exited cleanly yet...
	{
		do
		{
			portaddress = 0x0000002F;	//Write1 to 0x2F	
			data4 = 0xFF;			//
			IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
			if (!IoctlResult)                            // Did the IOCTL fail?
			{
				//printf("\nW1 FF@2F Ioctl failed with code %ld\n", GetLastError() );
				iMB = MessageBox(hwnd, "W1 FF@2F",
					NULL, MB_ICONSTOP | MB_OK); 
				goto final_exit;	
			}
			Sleep(100);
			//----------
			//Read from offset 0Fh
			portaddress = 0x0000000F;		//Read1 from 0x0F	//TIME data
			data4 = 0x00000000;
			IoctlResult = DoReadWriteAction(hAecPci, Read1, portaddress, &data4, &len);
			Sleep(100);
		} while (!DONEexitingIsrThread);
	}
	portaddress = 0x0000002F;	//Write1 to 0x2F to 'un prime the pump' and leave in 'ready to go' state.	
	data4 = 0x00;			//
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);

//----------
	// on this pass, prior to writing the 00h to 2Fh, clear the hardware Interrupt line driving
	//ability. Note: Better code would make sure that the ISR thread has closed prior to doing
	//this next step. If not closed, loop on the above until it is closed. This will keep
	//the driver happy and allow for proper application closing/exiting.
	/*++
	portaddress = 0x000000FC;	//Write4 to 0xFC	
	data4 = 0x00000000;			//IRQ DISABLE
	IoctlResult = DoReadWriteAction(hAecPci, Write4, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
	    //printf("\nW4 0@FC Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "Couldn't clear INTERRUPT enable.",
			NULL, MB_ICONSTOP | MB_OK);
		goto final_exit;
	}
	//----------
	Sleep(100);
	//----------
	portaddress = 0x0000002F;	//Write1 to 0x2F	
	data4 = 0x00;			//
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
	    //printf("\nW1 FF@2F Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "W1 00@2F",
			NULL, MB_ICONSTOP | MB_OK); 
		goto final_exit;	
	}	// --*/
	//----------
final_exit:
    if (!CloseHandle(hAecPci))                  // Close the Device "file".
    {
        //printf("Failed to close device.\n");
		iMB = MessageBox(hwnd, "Unable to Close the Aec PCI?-TC device.",
			NULL, MB_ICONSTOP | MB_OK);
    }
//----------

	return 0;
}
//################################################################
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// *********************  WINDOW PROC  ***************************
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//use this next line for win32 build
long WINAPI WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
//Use Next line if x64 build
//LRESULT WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
     {
     switch (message)						
          {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			
		  GetClientRect (hwnd, &rect) ;			

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if (bRnew)
		{
			bRnew = FALSE;		//reset this flag
			//lRTdat, lRUdat iReadCnt

			aecint = LtoStrTm(lRTdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
		       charStr,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_CENTER);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iReadCnt),
				&rect,
				DT_SINGLELINE | DT_RIGHT );
		}
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if (bGnew)			//print the GENERATOR data
		{		
			bGnew = FALSE;		//reset this flag
			//lGTdat, lGUdat
			aecint = LtoStrTm(lGTdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
			    charStr,
				aecint,
				&rect,
				DT_SINGLELINE | DT_VCENTER | DT_CENTER );
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iGenCnt),
				&rect,
				DT_SINGLELINE | DT_VCENTER | DT_RIGHT );
		}
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if (bVnew)	//print the video field interrupt timing...
		{
			bVnew = FALSE;		//reset flag value			
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iVidCnt),
				&rect,
				//DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
				DT_SINGLELINE | DT_CENTER | DT_BOTTOM);
		}
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if (bGPInew)
		{
			bGPInew = false;
			//Show iGpiCnt
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iGpiCnt),
				&rect,
				//DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
				DT_SINGLELINE | DT_CENTER | DT_BOTTOM);
			//show the lGPIdat as Xs&Os
			aecint = LtoStr12B(lGPIdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
		       charStr,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
		}
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		else	//something else	//Revision info???, size change
		{
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"READER"),
				&rect,
				DT_SINGLELINE );
			if (!ReaderAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_CENTER );
			//----------------------------------------------
			DrawText (hdc,		
				hhmmssff,
				wsprintf (hhmmssff,"GENERATOR"),
				&rect,
				DT_SINGLELINE | DT_VCENTER );
			if (!GeneratorAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_VCENTER | DT_CENTER );
			//-----------------------------------------------
			//*++	Leave for GPI
			DrawText (hdc,		
				hhmmssff,
				wsprintf (hhmmssff,"GPI"),
				&rect,
				DT_SINGLELINE | DT_BOTTOM );	// --*/


			//The follow is for debugging output messages
			/*++
			DrawText (hdc,		
				str_DeviceInfo,
				iLwchar,
				&rect,
				DT_SINGLELINE | DT_BOTTOM );	// --*/
			//DrawText (hdc, LPCSTR lpchText, int cchText, LPRECT lprc, UINT format);
			//		the return value (of wsprintf) is the number of characters stored in the output buffer...
			//iLwchar = wsprintf (str_DeviceInfo, _T(" PCIe-TC ver: %2.2X%c%c "), b8, b6, b7);
			//wsprintf (str_DeviceInfo, _T(" Read/Write capability test - errR/W = %d / %d"), dwErrCntR1_90h, dwErrCntW1_91h);
			//	WCHAR str_DeviceInfo[40];
			//  int iLwchar;
			//    --*/
			

			/*++	Remove if NOT GPI
			if(!VideoAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_BOTTOM | DT_CENTER );	//  --*/
		//-----------------------------------------------
		}
		EndPaint (hwnd, &ps) ;					
	       return 0 ;								

	  case WM_DESTROY:								
	       PostQuitMessage (0) ;					
	       return 0 ;								
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	
     }

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----------------------------------------------------------
//Convert a LONG (4byte) value into a character string of TIME (Tm)
//This does NOT mask embedded bits 
// use "dw = (dw & 0x3F7F7F3F);" to mask embedded bits IF needed
//before calling this routine.
//------------------------------------------------------------
int LtoStrTm(ULONG dw, char *chs)	
{
	wsprintf (chs,"%8.8X",dw);
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';
	return 11;
}
//
//-----------------------------------------------------------
//Convert a LONG (4byte) value into a 12 O/X character string
// use "dw = (dw & 0x3F7F7F3F);" to mask embedded bits IF needed
//before calling this routine. 'X' = 1 , 'O' = 0 (GND/Low).
//Simple but crude way to show individual pin values of GPI
//------------------------------------------------------------
int LtoStr12B(ULONG dw, char *chs)	
{
	ULONG d, d12;
	d = (dw & 0x0FFF0000);	//mask all but the 12 GPI bits
	//d = d / 0x10000;		//shift down 16 bits
	//wsprintf (chs,"%8.8X",dw);
	//12
	if (d & 0x08000000)
		chs[0] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[0] = 'O';
	//11
	if (d & 0x04000000)
		chs[1] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[1] = 'O';
	//10
	if (d & 0x02000000)
		chs[2] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[2] = 'O';
	//9
	if (d & 0x01000000)
		chs[3] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[3] = 'O';

	chs[4] = ' ';	//add a space after each nibble

	//8
	if (d & 0x00800000)
		chs[5] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[5] = 'O';
	//7
	if (d & 0x00400000)
		chs[6] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[6] = 'O';
	//6
	if (d & 0x00200000)
		chs[7] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[7] = 'O';
	//5
	if (d & 0x00100000)
		chs[8] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[8] = 'O';

	chs[9] = ' ';	//add a space after each nibble

	//4
	if (d & 0x00080000)
		chs[10] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[10] = 'O';
	//3
	if (d & 0x00040000)
		chs[11] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[11] = 'O';
	//2
	if (d & 0x00020000)
		chs[12] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[12] = 'O';
	//1
	if (d & 0x00010000)
		chs[13] = 'X'; //'X' when SET, '0' when CLEAR
	else chs[13] = 'O';

	chs[14] = 0; //EOL
	return 14;
}
//-----------------------------------------------------------
/*++	****** DEFINED ACTIONS SUPPORTED BY THE DRIVER ******
AECPCI_ACTION parameter must be one of the following!
NOTE: The values ARE case sensitive!

    NOP_THING,         //  No operation		0                   0
    Read1,              //  input byte			offset				data (in)	
    Read2,              //  input word			offset				data (in)
    Read4,              //  input long			offset				data (in)
    Write1,             //  output byte			offset				data (out)
    Write2,             //  output word 		offset				data (out)
    Write4,             //  output long 		offset				data (out)

	SND_CMD,		//send command			command(out)		intcode(in)
					//read the NEXT INTCODE - fixed OFFSET read / enable next
	GET_INT			//get int code			0 (don't care?)		intcode(in)
					//
	RTM,			//  input long			0 (don't care?)		data (out)
					//Read the TIME bits at offset 10h (transition tolerent) DWORD
	RUB,			//  input long			0 (don't care?)		data (out)
					//Read the USER bits at offset 14h (transition tolerent) DWORD
	REB,			//  input byte			0 (don't care?)		data (out)
					//Read the EMBEDDED bits at offset 18h (transition tolerent) UCHAR
	NextInt,		//  output byte			0 (don't care)		data (out)
					//Queue an IRP for the ISR/DPC to complete

				--*/
BOOL 
DoReadWriteAction(
				  IN HANDLE hOpen, 
				  IN enum AECPCI_ACTION act, //was (in error) IN enum AECPCI_ACTION_ITEM act, 
				  IN ULONG port,
				  IN OUT PULONG pdata,
				  IN PULONG pLB
				  )
{
	BOOL status;
		//enum AECPCI_ACTION	action;		// action to perform
		//ULONG					port;       // port address
		//ULONG					value;      // input or output data
	AECPCI_ACTION_ITEM		ai;			// *PAECPCI_ACTION_ITEM;
	ai.action = act;
	ai.port = port;
	ai.value = *pdata;
		//For 'DeviceIoControl', A Nonzero return value indicates success. 
		// a Zero indicates failure. To get extended error info, call GetLastError. 
	if (status = DeviceIoControl(		
                hOpen,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_BUFFER,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ai,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ai),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ai,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ai),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				pLB,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                )				
		)
	{		*pdata = ai.value;		}

	return status;
}
//---------------------------------------------------------------------------------
//This sample program uses a 2nd copy of the 'DeviceIoControl' to keep each thread's
//access to the PCI/PCIe device from accessing simultaneously. Note that the driver
//uses spin locks to
BOOL 
DoReadWriteActionISR(
				  IN HANDLE hOpen, 				  
				  IN enum AECPCI_ACTION act, //was (in error) IN enum AECPCI_ACTION_ITEM act, 
				  IN ULONG port,
				  IN OUT PULONG pdata,
				  IN PULONG pLB
				  )
{
	BOOL status;
	AECPCI_ACTION_ITEM		ai;			// *PAECPCI_ACTION_ITEM;
	ai.action = act;
	ai.port = port;
	ai.value = *pdata;
		//For 'DeviceIoControl', A Nonzero return value indicates success. 
		// a Zero indicates failure. To get extended error info, call GetLastError. 
	if (status = DeviceIoControl(		
                hOpen,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_BUFFER,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ai,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ai),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ai,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ai),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				pLB,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                )				
		)
	{		*pdata = ai.value;		}
	return status;
}

//---------------------------------------------------------------------------------
//This function is NEW (For hardware event message handling) 11/08
//It is very similar to the other fuctions above, but has a
// handle argument that changes size (32 or 64 bit) depending upon the build
// environment. The 'structure' passed to the driver therefore differs in
// its size here.
BOOL 
DoReadWriteActionEventSetup(
				  IN HANDLE hOpen, 
				  IN enum AECPCI_ACTION act, //was (in error) IN enum AECPCI_ACTION_ITEM act, 
				  IN HANDLE hEvent,
				  IN OUT PULONG pdata,
				  IN PULONG pLB
				  )
{

	BOOL status;
		//enum AECPCI_ACTION	action;		// action to perform
		//handle				hWaitEventHandle;       // event handle to pass
	AECPCI_EVENT_HANDLE_ITEM		ae;	
	ae.action = act;
	ae.hWaitEventHandle = hEvent;
		//For 'DeviceIoControl', A Nonzero return value indicates success. 
		// a Zero indicates failure. To get extended error info, call GetLastError. 
		//If the operation fails or is pending, the return value is zero. 
		//To get extended error information, call GetLastError.
	status = DeviceIoControl(		
                hOpen,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_EVENT,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ae,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ae),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ae,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ae),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				pLB,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                );				

	return status;
}
//============================================================================
//============================================================================
//The 'hAecPciX' is the device handle passed from the main thread
DWORD TcISR1(HANDLE hAecPciX)	//FIRST BOARD THAT THE DRIVER SEES (Device0)
{
// ++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++
//	int a,b,c;
//	char buffer[30];
// ++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++

	ULONG		pAddr, d4, dLn, uL4, d4CMD;
	DWORD		dwRet;
	BOOLEAN		IOResult;
	//BOOLEAN		ok_q;
	UCHAR		iCd;
	UCHAR		b1, b2;
	UCHAR		tempE0, tempE1;
	HANDLE		hIsrEvent;

	BOOL status;
	exiting = false;	//Global

//	pAddr = 0x00000008;	//board 'capabilities' register
//	d4 = 0x00;
//	DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
//	BrdCapCode = (UCHAR)d4;
	//NOTE: 'BrdCapCode' value was set in the main process prior to starting this thread

	//---------
	//Disable hardware interrupts on the way in and out of this thread, enabled prior to looping
	pAddr = 0x000000FC;		//hardware interupt enable/disable reg.
	d4 = 0x00000000;				//00000000h = 'disable' value, (00000010h = 'enable')
	DoReadWriteAction(hAecPciX, Write4, pAddr, &d4, &dLn);

	//Note: For PCIe-TC, a SINGLE byte (Write1) does the same as the above. ie...
//	pAddr = 0x000000FC;		//hardware interupt enable/disable reg.
//	d4 = 0x00000000;				//'disable' value
//	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);
	//---------

	//Disable 'int' enable bit at 2Eh
	pAddr = 0x0000002E;		//Write1 to 0x2E	
	d4 = 0x00;			//INT READER/GEN/VIDEO FLAG ENABLES
	IoctlResult = DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);
	
	d4CMD = 0x00000020;	//start with 'IDLE'
	//Now add to this to enable all the features available
//	if ((BrdCapCode & 0x80) != 0)	//there is a VITC generator
//		d4CMD = d4CMD + 0x08;	//add 'Bit3'
	if ((BrdCapCode & 0x40) != 0)	//there is a VITC reader
		d4CMD = d4CMD + 0x02;	//add 'Bit2'
	if ((BrdCapCode & 0x20) != 0)	//there is a LTC generator
		d4CMD = d4CMD + 0x04;	//add 'Bit1'
	if ((BrdCapCode & 0x10) != 0)	//there is a LTC reader
		d4CMD = d4CMD + 0x01;	//add 'Bit0'

//	pAddr = 0x20;				//command to send
//	d4 = 0x00000000;			//null return value
//	if (DoReadWriteAction(hAecPciX, SND_CMD, pAddr, &d4, &dLn))
//		uL4 = d4;

//	pAddr = 0x000000FE;	//Int Pending?
//	d4 = 0x00;
//	DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
//	b1 = (UCHAR)d4;

	//pAddr = 0x0000002F;		//command to send
	//pAddr = d4CMD;	//command to send (based on hardware ability) determined above
	pAddr = 0x21;				//ie: For an 'LTC Reader w/GPIO, use '0x21'.
	d4 = 0x00000000;			//null return value
	if (DoReadWriteAction(hAecPciX, SND_CMD, pAddr, &d4, &dLn))
		uL4 = d4;

	//Check the status of the 'board <-> host' mailbox/handshake & ints
	//by reading byte at FEh. See 'refman.pdf' for details.
	//Note that the driver 'SND_CMD' operation does this within the
	//device protocol interface as an 'all in one' operation within the driver.
	//You can read it's (FEh) status at anytime however.
	//Within the 'loop' that starts below, you should NEVER be able to
	//read this register and find that 'bit0' is '1'. The fact that the
	//device asserts an IRQ (hardware ISR within the driver if the
	//hardware interrupts are enabled via write '10h' to FCh prior) and
	//the ISR clears this bit before setting the EVENT (event method) or 
	//completing the ISR and returning 'code' (for NON-event method)
	//The lines that follow just below are prior to the 'loop'.
	//
//	pAddr = 0x000000FE;	//Int Pending? DEBUG 
//	d4 = 0x00;
//	DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
//	b1 = (UCHAR)d4;
/*++	//For the general case, if the PCI? card has TC generator ability, 
		//enable it now to start generating TC
	if ((BrdCapCode & 0xA0) != 0)	//there is a generator to start?
	{
		//send "command" to board, (write byte to 2Fh
		pAddr = 0x00000048;			//command to send
		d4 = 0x00000000;			//start "generator"
		if (DoReadWriteAction(hAecPciX, SND_CMD, pAddr, &d4, &dLn))
			uL4 = d4;	//command response value
//		pAddr = 0x000000FE;	//Int Pending? DEBUG
//		d4 = 0x00;
//		DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
//		b1 = (UCHAR)d4;
	}
// --*/


	//"Prime the ISR pump" for use with the PCI-TC & PCIe-TC card use

	//-----------
	//send partial "command" to board, (write 'cmd' byte to 2Fh0) not the same as SND_CMD
	pAddr = 0x0000002F;			//command write address
	d4 = 0x0000005B;			//cmd, a 'do nothing' commmand value
	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);
	
	//Instead of a short 'sleep', you can poll 'FEh' for 'ready'
	//Sleep(10);
	do {
		pAddr = 0x000000FE;	//Int Pending? DEBUG
		d4 = 0x00;
		DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
		b1 = (UCHAR)d4;		
	} while ((b1 & 0x01) != 0x01); //while not bit0
	//read once more for good measure
	pAddr = 0x000000FE;	//Int Pending? DEBUG
	d4 = 0x00;
	DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);

	//Go see what the 'code' is that caused the FE.0 bit to set
	//read '0Fh' (this action also clears int pending bit FE.0)
	pAddr = 0x0000000F;	//board 'int code' output
	d4 = 0x00;
	DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
	//It is assumed that the 'code' is '5Bh' to match command that was sent
	//but we don't really care here. We just needed to get the card
	//to an state where we can set up and enable hardware interrupt
	//signalling without triggering an interrupt before we are ready to
	//handle it. The action of 'write1' to offset '2Fh' with value '00h'
	// is the operation that tells the card we are 'ready' to go.
	//Note that this is what is done as the first action once
	//we are in the 'loop', just prior to waiting for the event.
	//If this action sets the event, then the 'wait' will be VERY
	//short.

	//Before the 'w1@2Fh->00h' operation, we need to enable IRQs
	//for what we want the card to notify us of when it happens.
	//Two things must be done: 1)Enable GLOBAL IRQ assertion for
	//any 2)'type' allowed (by bits set at 2Eh).
	//enable hardware interrupts (write4 10h to FCh
	//1)
	pAddr = 0x000000FC;		//hardware interupt enable/disable reg.
	d4 = 0x00000010;				//'enable' value
	DoReadWriteAction(hAecPciX, Write4, pAddr, &d4, &dLn);
	//Note that the following 'w1' could be used instead for PCIe-TC
//	pAddr = 0x000000FC;		//hardware interupt enable/disable reg.
//	d4 = 0x00000010;				//'enable' value
//	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);

	//2)
	//reset the 'int enable' bits at 2Eh	Allow all 'normal' interrupts
	pAddr = 0x0000002E;			//command input reg.
	d4 = 0x00000007F;			//enable interrupts, See the bit map for
								//this register in refman.pdf
								//For PCIe-TC, the GPI is signaled instead of
								//the 'Serial receive'(Rx) when setting bit4.
	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);

// / *++ EVENT SETUP-  InterruptServiceRoutine (ISR) SETUP section. Required if using EVENT method. 
		//typedef struct _AECPCI_EVENT_HANDLE_ITEM
		//	{
		//		enum AECPCI_ACTION  action; // action to perform
		//		HANDLE				hWaitEventHandle;	//handle from 'CreateEvent'.
		//	} AECPCI_EVENT_HANDLE_ITEM, *PAECPCI_EVENT_HANDLE_ITEM;
		//IOCTL_AECPCI_PROCESS_EVENT
		//if DoReadWriteActionEventSetup(hAecPciX, WAITEVENT, hEvent, &d4, &dLn)
		// ...

	//Open and acquire an event handle that can be 'waited' on and that
	//is passed to the device driver to 'signal' when needed
	hIsrEvent = CreateEvent(NULL, TRUE, FALSE, NULL); //Get Event Handle
	//(NULL security... ,/ TRUE must RESET ,/ NOT Signaled initially ,/ no name)
	if (hIsrEvent == NULL)	//error
	{
			exiting = true;	//exiting will occur befor loops
	}
	else //make IOCTL call to driver to setup Event signalling within ISR/DPC...
	{
		if (DoReadWriteActionEventSetup(hAecPciX, WAITEVENT, hIsrEvent, &d4, &dLn))
		{
			exiting = false;
			//Note for PCIe-TC users: The device driver has 2 'special' status details that
			//can be used to get some additional insight into the above 'eventsetup' call.
			//1) A 'read4' operation from offset '0x98' will return the low 32bits of the 
			//device handle. In 32bit OS, that should be exact, for 64, it will be the low half.
			//This will help to show that the driver did get the 'handle' correctly.
			//2) A 'read4' operation from offset '0x99' will return a value of 0x00, 0x01 or 0x02.
			// 0 = expected result if 'hIsrEvent' handle is NULL (as is the case when shutting down)
			// 1 = some error - Insufficient resources
			// 2 = successful setup to use the handle provided
//			pAddr = 0x00000098;//Read4 from 0x98 - 
//			d4 = 0x00000000;
//			if (DoReadWriteAction(hAecPciX, Read4, pAddr, &d4, &dLn))
//				lRUdat = d4;
//			//does lRUdat == hIsrEvent value?
//			pAddr = 0x00000099;//Read4 from 0x99 - 
//			d4 = 0x00000000;
//			if (DoReadWriteAction(hAecPciX, Read4, pAddr, &d4, &dLn))
//				lRTdat = d4;	//lRUdat, lRTdat
//			//Is value == 0, 1 or 2. 2 is what is desired here.
	}
		else	//some type of error in IOCTL call
		{
			exiting = true;
		}
	}

// EVENT SETUP END 
	if (!exiting)	// Last item to take care of prior to loop IF GPI version card
	{		
		pAddr = 0x00000006;	//Software Rev letter
		d4 = 0x00;
		DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
		b1 = (UCHAR)d4;

		//Enable the GPIO operations (set bit E9.7, CUSTOM GPI CARD)
		pAddr = 0x000000E9;			//command input reg.
		d4 = 0x0000008F;			//enable GPIO by setting bit7
		if (b1 == 'R')	//CUSTOM GPIO12
			DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);
	}

	//continue into normal ISR operations
    							//THIS 'WHILE' LOOP IS THE ISR FOR THE 
								//PCI (DEVICE0) BOARD.  THIS EXAMPLE UPDATES A
								//COUNTER THAT SHOWS THE NUMBER OF EACH TYPE OF
								//INTERRUPT THAT HAS OCCURED.  
								//THIS CODE DOES ASSUME THAT THE BOARD IS CAPABLE OF
								//READING TIME CODE.  
								//THE ISR WILL LOOP INDEFINITLY.  TO STOP
								//THE ISR, set the "exiting" flag TRUE!
								//ALSO, CLEAR THE BIT OFFSET FE.4 BY MAKING A
								//"Write4" CALL TO OFFSET FCh WITH A VALUE OF 00h.
								//THIS WILL STOP ANY OF THE SOFTWARE INTERRUPTS FROM
								//GENERATING HARDWARE INTERRUPTS.
								//IN THIS EXAMPLE, THIS IS DONE JUST AFTER THE MAIN LOOP
	while ( ! exiting )			//BEGINS THE EXIT CODE.
    {  
		//The following section can be ignored if using the EVENT notification method!
				/* ++ IRP IOCTL InterruptServiceRoutine (ISR) method code START
				//pAddr = 0x00000010;
				//d4 = 0x00000000;
				//POLLED method
				//IOResult = DoReadWriteAction(hAecPci, GET_INT, pAddr, &d4, &dLn);

				//ISR QUEUED  method
				//Sleep(33);	//TEMP debug
				//This call is similar to the DLL file "AEC_PCTC_ISR_1"
				pAddr = 0x00000000;	// n/a
				//This is the driver IRP that will "park and wait" for the interrupt to occur
				//and then return with the interrupt code once it happens.
				IOResult = DoReadWriteActionISR(hAecPciX, NextInt, pAddr, &d4, &dLn);
				// IRP InterruptServiceRoutine (ISR) code END --*/ 		


		///* ++ EVENT InterruptServiceRoutine (ISR) code START
			//1st - Write the value '00h' to offset 2Fh. This will "enable" the next interrupt when it occurs.
		// It might enable an interrupt that is already pending, so the "wait" in the following lines
		// may already be satisfied when the call to wait is made and it will return immediately.
		pAddr = 0x0000002F;	//Enable Next "command"
		d4 = 0x00000000;
		DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);

			//2nd - Wait for EVENT. You can set this wait for INFINITE or some timeout period.
		//	This example will use a ONE second timeout to ensure the loop runs but does NOT
		//	loop through the entire loop, just allows for "exiting" checks
		do
		{
            dwRet = WaitForSingleObject(hIsrEvent, 1000);	
				//Unless nothing is enabled for harware interrupts and/or no signals are
				// active, this 'timeout' period will generally not occur before the event is signalled.
				//In any event, the event MUST be able to be signalled or timeout in order
				//for the thread to exit without hanging. Developers can investigate additional ways
				//to exit cleanly. I use the 1sec timeout and then wait again after a 'look'
				//to see if the code should proceed to exit.
										
				//----------
			//Did the wait time out? check for exiting is YES, then go back and wait
			if (dwRet == WAIT_TIMEOUT)
			{
				pAddr = 0x00000033;	//read from 0x33	//This is a device register
												//that is otherwise used in the comparator ops.
				d4 = 0x00;				//Normal "not allowed/not used" value
												//This program uses this register to handshake threads
												//This is a hard way to pass info to the ISR thread
				DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
				if ((d4 & 0x00000080) != 0x00)	//was bit7 set?
				{
					exiting = true;	//force this ISR loop to stop looping
					dwRet = 0;		//force this inner 'do-while' loop to exit
				}
			}
				//---------
		} while (dwRet == WAIT_TIMEOUT);

			//3rd - Go read the "interupt code" (ie: read1 from 0Fh). This value is low byte of 'd4' on return.
		// Then continue the same as for the IRP method
		pAddr = 0x0000000F;
		d4 = 0x00000000;
		IOResult = DoReadWriteAction(hAecPci, Read1, pAddr, &d4, &dLn);

			//4th - Reset the event for next time around the loop. 
		//The device driver SETS the event. This application REsets the event.
		ResetEvent(hIsrEvent);

		// EVENT InterruptServiceRoutine (ISR) difference code END --*/ 		


		// READ output---->	do 'stuff' as needed based upon the 'code' from 0Fh.
		if (IOResult)                            // Did the IOCTL succeed?
		{
			iCd = (UCHAR)d4;		//convert returned ulong value to "code" byte
			switch (iCd)	//process the interrupt depending upon what it is
			{
			case (0x13):	//tc reader interrupt (get time & user (don't worry about Embedded)			
				bRnew = TRUE;
				iReadCnt++;				
				pAddr = 0x00000010;//Read4 from 0x10 - TIME data -(RTM)
				d4 = 0x00000000;
				if (DoReadWriteAction(hAecPciX, Read4, pAddr, &d4, &dLn))
					lRTdat = (d4 & 0x3F7F7F3F);	//This data is used to 'display'
				break;
			case (0x4C):	//tc generator interrupt
				bGnew = TRUE;
				iGenCnt++;
				pAddr = 0x00000040;//Read4 from 0x40 - Gen. TIME data -
				d4 = 0x00000000;
				if (DoReadWriteAction(hAecPciX, Read4, pAddr, &d4, &dLn))
					lGTdat = (d4 & 0x3F7F7F3F);	//mask the embedded bits
				//Could put an 'else' case if desired. Not too important for sample code
				break;

			case (0x44):	//Video field int has been triggered
				iVidCnt++;
				bVnew = TRUE;

			case (0x88):	//Serial RX (PCI-TC) OR GPI (PCIe-TC) signal has triggered
				iGpiCnt++;
				bGPInew = true;
				//lGPIdat
				//A 'read4' operation (on DWORD boundary) takes the same amount of time as a 'read1'
				//Get the two bytes in a single operation and handle/process as needed.
				pAddr = 0x00000008;//Read4 from 0x08 (Bh/Ah/9h/8h) - (filtered GPI at 0Ah, 0Bh)
				d4 = 0x00000000;
				if (DoReadWriteAction(hAecPciX, Read4, pAddr, &d4, &dLn))
					lGPIdat = d4;	//this data is used to show/display 'GPI pin' levels
				//Could put an 'else' case if desired. Not too important for sample code
				break;

			default:	//command response, compare, misc...NAK
				iOtherCnt++;	
				//do other processing if desired for the unhandled 'code' here
			}
		}    
		else	//comes here if the IOCTL call reading the 'code' had an error
		{
			//Sleep(500);
			MessageBeep(0xFFFFFFFF);
		}
			
		//----------
		pAddr = 0x00000033;	//read from 0x33	//This is a device register
										//that is otherwise used in the comparator ops.
		d4 = 0x00;			//This program uses this register to handshake threads
										//This is a crude way to pass info to the ISR thread
		DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
		if ((d4 & 0x00000080) != 0x00)
			exiting = true;	//cause loop to exit
		//---------

	}	//end of 'WHILE (!exiting)' loop
	// LOOP END ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

	//Start the 'cleanup' of the card/driver so it shuts down without any 'hangs'.
	DONEexitingIsrThread = true;

	//Disable hardware interrupts on the way out....
	pAddr = 0x000000FC;		//hardware interupt enable/disable reg.
	d4 = 0x00000000;				//'disable' value
	DoReadWriteAction(hAecPciX, Write4, pAddr, &d4, &dLn);
	//PCIe-TC card can do it a a 'Write1' also if desired.
//	pAddr = 0x000000FC;		//hardware interupt enable/disable reg.
//	d4 = 0x00000000;				//'disable' value
//	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);

	pAddr = 0x0000002E;		//disable all automatic hardware interupts
	d4 = 0x00000000;				//'disable' value
	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);

	///*++ EVENT handler shutdown START
	DoReadWriteActionEventSetup(hAecPciX, WAITEVENT, NULL, &d4, &dLn);	//pass a null handle to 'decrement' in driver	

	CloseHandle(hIsrEvent);// --*/ //EVENT handler shutdown END
	//---------


	pAddr = 0x00000006;	//Software Rev letter
	d4 = 0x00;
	DoReadWriteAction(hAecPciX, Read1, pAddr, &d4, &dLn);
	b1 = (UCHAR)d4;

	//DISABLE the GPIO operations (clr bit E9.7, CUSTOM GPI CARD)
	pAddr = 0x000000E9;			//command input reg.
	d4 = 0x0000000F;			//disable GPIO by setting bit7
	if (b1 == 'R')	//CUSTOM GPIO12
		DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);
	

	//-----------
	pAddr = 0x0000002F;			//command input reg.
	d4 = 0x00000000;			//enable next (normal/Non-isr mode)
	DoReadWriteAction(hAecPciX, Write1, pAddr, &d4, &dLn);
	//-----------


    return(NO_ERROR);       // can't get here till exiting!
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	      // END OF CODE	END OF CODE		END OF CODE